Index: branches/src/ProcessManagement/ProcessManagement/Forms/SubForms/FrmConstructionDiag.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/SubForms/FrmConstructionDiag.cs	(revision 50)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/SubForms/FrmConstructionDiag.cs	(revision 51)
@@ -33,6 +33,8 @@
             DispConstructionCode,
             ConstructionName,
             ConstructionCode,
+            OrderersDivision,
+            OrderersCode,
         }
 
         /// <summary>
@@ -49,10 +51,41 @@
             /// </summary>
             Construction,
         }
+
+        /// <summary>
+        /// 検索タイプ           Add BIT 2017/02/22
+        /// </summary>
+        public enum SelectConstructionType
+        {
+            /// <summary>
+            /// 全て（工事結合）
+            /// </summary>
+            All = 0,
+            /// <summary>
+            /// 進行中（購入品選択、資材貸出、資材返却）
+            /// </summary>
+            Ongoing,
+            /// <summary>
+            /// 一括請求対象
+            /// </summary>
+            CombinedOrder,
+            /// <summary>
+            /// 分割請求対象
+            /// </summary>
+            SeparateBilling,
+                
+        }
+
         #endregion
 
         #region 変数
+
         /// <summary>
+        /// 部署コード
+        /// </summary>
+        private int m_DepartmentCode = 0;
+
+        /// <summary>
         /// 担当者コード
         /// </summary>
         private int m_PersonCode = 0;
@@ -63,6 +96,11 @@
         private int m_PersonCharge = 0;
 
         /// <summary>
+        /// 起動処理番号
+        /// </summary>
+        private int m_ProcessNo = 0;
+
+        /// <summary>
         /// 工事番号
         /// </summary>
         private int m_ConstructionCode = 0;
@@ -72,14 +110,38 @@
         private string m_ConstructionName = string.Empty;
 
         /// <summary>
+        /// 発注者区分
+        /// </summary>
+        private int m_OrderCotegory = 0;
+        /// <summary>
+        /// 発注者番号
+        /// </summary>
+        private int m_OrdererCode = 0;
+        
+        /// <summary>
         /// 終了状態フラグ
         /// </summary>
         private DialogResult m_EndButton = DialogResult.None;
 
+        /// <summary>   
+        /// 検索タイプ           Add BIT 2017/02/22
+        /// </summary>
+        private int m_SelectType = (int)SelectConstructionType.All;
+
         #endregion
 
         #region プロパティ
+
         /// <summary>
+        /// 部署コード
+        /// </summary>
+        public int DepartmentCode
+        {
+            get { return m_DepartmentCode; }
+            set { m_DepartmentCode = value; }
+        }
+
+        /// <summary>
         /// 担当者コード
         /// </summary>
         public int PersonCode
@@ -121,6 +183,41 @@
             get { return m_EndButton; }
         }
 
+        /// <summary>
+        /// 起動処理番号
+        /// </summary>
+        public int ProcessNo
+        {
+            get { return m_ProcessNo; }
+            set { m_ProcessNo = value; }
+        }
+
+        /// <summary>
+        /// 発注者区分
+        /// </summary>
+        public int OrderCotegory
+        {
+            get { return m_OrderCotegory; }
+            set { m_OrderCotegory = value; }
+        }
+        /// <summary>
+        /// 発注者番号
+        /// </summary>
+        public int OrdererCode
+        {
+            get { return m_OrdererCode; }
+            set { m_OrdererCode = value; }
+        }
+
+        /// <summary>
+        /// 検索タイプ       Add BIT 2017/02/22
+        /// </summary>
+        public int SelectType
+        {
+            get { return m_SelectType; }
+            set { m_SelectType = value; }
+        }
+
         #endregion
 
         #region フォーム初期化
@@ -171,13 +268,10 @@
         {
             DataGridView dgv = dgvMaster;
             DataGridViewRow dgvRow = dgv.CurrentRow;
-            
-            // 工事番号取得
-            m_ConstructionCode = CommonMotions.cnvInt(dgvRow.Cells[(int)DispGridColumn.ConstructionCode].Value);
-            // 工事名称取得
-            m_ConstructionName = CommonMotions.cnvString(dgvRow.Cells[(int)DispGridColumn.ConstructionName].Value);
 
-            m_EndButton = DialogResult.OK;
+            // 選択データセット
+            DataSelectProc();
+
             this.Close();
         }
         #endregion
@@ -198,16 +292,45 @@
             // グリッドクリック以外は処理しない
             if (e.RowIndex < 0) return;
 
-            // 工事番号取得
-            m_ConstructionCode = CommonMotions.cnvInt(dgvRow.Cells[(int)DispGridColumn.ConstructionCode].Value);
-            // 工事名称取得
-            m_ConstructionName = CommonMotions.cnvString(dgvRow.Cells[(int)DispGridColumn.ConstructionName].Value);
+            // 選択データセット
+            DataSelectProc();
 
-            m_EndButton = DialogResult.OK;
             this.Close();
         }
         #endregion
 
+        #region 選択データセット処理
+        /// <summary>
+        /// 選択データセット処理
+        /// </summary>
+        private void DataSelectProc()
+        {
+            DataGridView dgv = dgvMaster;
+            DataGridViewRow dgvRow = dgv.CurrentRow;
+            try
+            {
+                // 工事番号取得
+                m_ConstructionCode = CommonMotions.cnvInt(dgvRow.Cells[(int)DispGridColumn.ConstructionCode].Value);
+                // 工事名称取得
+                m_ConstructionName = CommonMotions.cnvString(dgvRow.Cells[(int)DispGridColumn.ConstructionName].Value);
+
+                if (m_ProcessNo == (int)ClsExcute.ProcessExecuteNo.OrderJoin)
+                {
+                    // 発注者区分
+                    m_OrderCotegory = CommonMotions.cnvInt(dgvRow.Cells[(int)DispGridColumn.OrderersDivision].Value);
+                    // 発注者番号
+                    m_OrdererCode = CommonMotions.cnvInt(dgvRow.Cells[(int)DispGridColumn.OrderersCode].Value);
+                }
+
+                m_EndButton = DialogResult.OK;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
         #region 初期表示処理
         /// <summary>
         /// 初期表示処理
@@ -220,7 +343,7 @@
                 dgvMaster.Rows.Clear();
 
                 // 一覧表示
-                ItemListDisplay();
+                ConstructionListDisplay();
 
             }
             catch (Exception ex)
@@ -234,7 +357,7 @@
         /// <summary>
         /// 工事一覧表示処理
         /// </summary>
-        private void ItemListDisplay()
+        private void ConstructionListDisplay()
         {
             IOConstructionBaseInfo BaseDB = new IOConstructionBaseInfo();
             try
@@ -241,24 +364,98 @@
             {
                 dgvMaster.Rows.Clear();
 
-                // 進行中案件をを検索する
-                string strSQL = "SELECT A.CONSTRUCTIONCODE, B.DETAILSTRING";
-                strSQL += " FROM CONSTRUCTIONBASEINFO A, CONSTRUCTIONBASEINFODETAIL B, CONSTRUCTIONLEDGER C";
-                strSQL += string.Format(" WHERE (A.CONSTRUCTIONCODE = B.CONSTRUCTIONCODE AND B.DETAILNO = {0})", (int)ConstructionBaseInfoDetail.DetailDataNo.ConstructionName);
-                strSQL += " AND A.CONSTRUCTIONCODE = C.CONSTRUCTIONCODE AND C.COMPLATEFLG = 0";
-                switch (m_PersonCharge)
-                {
-                    case (int)PersonChargePoint.Sales:
-                        /// 営業担当検索
-                        strSQL += string.Format(" AND A.SalesPersonCode = {0}", m_PersonCode);
-                        break;
-                    case (int)PersonChargePoint.Construction:
-                        /// 工事担当者
-                        strSQL += string.Format(" AND (A.ConstructionPersonCode = {0} OR A.ConstrSubPersonCode = {0} OR A.ConstructionInstructor = {0})", m_PersonCode);
-                        break;
+                string strSQL = string.Empty;
+
+////                if (m_ProcessNo == (int)ClsExcute.ProcessExecuteNo.TAndPCosts)      Del BIT 2017/02/22
+                if (m_SelectType == (int)SelectConstructionType.Ongoing)                    // 検索タイプが進行中 Add BIT 2017/02/22
+                {   // ----- 購入品選択の場合
+                    // 進行中案件を検索する
+                    strSQL = "SELECT A.CONSTRUCTIONCODE, B.DETAILSTRING";
+                    strSQL += " FROM CONSTRUCTIONBASEINFO A, CONSTRUCTIONBASEINFODETAIL B, CONSTRUCTIONLEDGER C";
+                    strSQL += string.Format(" WHERE (A.CONSTRUCTIONCODE = B.CONSTRUCTIONCODE AND B.DETAILNO = {0})", (int)ConstructionBaseInfoDetail.DetailDataNo.ConstructionName);
+                    strSQL += " AND A.CONSTRUCTIONCODE = C.CONSTRUCTIONCODE AND C.COMPLATEFLG = 0";
+
+                    switch (m_PersonCharge)
+                    {
+                        case (int)PersonChargePoint.Sales:
+                            /// 営業担当検索
+                            strSQL += string.Format(" AND A.SalesPersonCode = {0}", m_PersonCode);
+                            break;
+                        case (int)PersonChargePoint.Construction:
+                            /// 工事担当者
+                            strSQL += string.Format(" AND (A.ConstructionPersonCode = {0} OR A.ConstrSubPersonCode = {0} OR A.ConstructionInstructor = {0})", m_PersonCode);
+                            break;
+                    }
+                    strSQL += " ORDER BY A.ConstructionPeriodStart DESC";
                 }
-                strSQL += " ORDER BY A.ConstructionPeriodStart DESC";
+                else if (m_SelectType == (int)SelectConstructionType.CombinedOrder)                    // 検索タイプが一括請求 Add BIT 2017/02/22
+                {   // ----- 請求入力（一括請求）の場合
+                    // 進行中＋一括請求を検索する
+                    strSQL = "SELECT A.CONSTRUCTIONCODE, B.DETAILSTRING";
+                    strSQL += " FROM CONSTRUCTIONBASEINFO A, CONSTRUCTIONBASEINFODETAIL B, CONSTRUCTIONLEDGER C";
+                    strSQL += string.Format(" WHERE (A.BillingSplitFlg = 0 AND A.CONSTRUCTIONCODE = B.CONSTRUCTIONCODE AND B.DETAILNO = {0})", (int)ConstructionBaseInfoDetail.DetailDataNo.ConstructionName);
+                    strSQL += " AND A.CONSTRUCTIONCODE = C.CONSTRUCTIONCODE AND C.COMPLATEFLG = 0 ";
 
+                    switch (m_PersonCharge)
+                    {
+                        case (int)PersonChargePoint.Sales:
+                            /// 営業担当検索
+                            strSQL += string.Format(" AND A.SalesPersonCode = {0}", m_PersonCode);
+                            break;
+                        case (int)PersonChargePoint.Construction:
+                            /// 工事担当者
+                            strSQL += string.Format(" AND (A.ConstructionPersonCode = {0} OR A.ConstrSubPersonCode = {0} OR A.ConstructionInstructor = {0})", m_PersonCode);
+                            break;
+                    }
+                    strSQL += " ORDER BY A.ConstructionPeriodStart DESC";
+                }
+                else if (m_SelectType == (int)SelectConstructionType.SeparateBilling)                    // 検索タイプが分割請求 Add BIT 2017/02/22
+                {   // ----- 請求入力（分割請求）の場合
+                    // 進行中＋一括請求を検索する
+                    strSQL = "SELECT A.CONSTRUCTIONCODE, B.DETAILSTRING";
+                    strSQL += " FROM CONSTRUCTIONBASEINFO A, CONSTRUCTIONBASEINFODETAIL B, CONSTRUCTIONLEDGER C";
+                    strSQL += string.Format(" WHERE (A.BillingSplitFlg = 1 AND A.CONSTRUCTIONCODE = B.CONSTRUCTIONCODE AND B.DETAILNO = {0})", (int)ConstructionBaseInfoDetail.DetailDataNo.ConstructionName);
+                    strSQL += " AND A.CONSTRUCTIONCODE = C.CONSTRUCTIONCODE AND C.COMPLATEFLG = 0 ";
+
+                    switch (m_PersonCharge)
+                    {
+                        case (int)PersonChargePoint.Sales:
+                            /// 営業担当検索
+                            strSQL += string.Format(" AND A.SalesPersonCode = {0}", m_PersonCode);
+                            break;
+                        case (int)PersonChargePoint.Construction:
+                            /// 工事担当者
+                            strSQL += string.Format(" AND (A.ConstructionPersonCode = {0} OR A.ConstrSubPersonCode = {0} OR A.ConstructionInstructor = {0})", m_PersonCode);
+                            break;
+                    }
+                    strSQL += " ORDER BY A.ConstructionPeriodStart DESC";
+                }
+                ///                else if (m_ProcessNo == (int)ClsExcute.ProcessExecuteNo.OrderJoin) Del BIT 2017/02/22
+                else                                // Add BIT 2017/02/22
+	            {
+                    // 対象全ての案件を検索する
+                    strSQL = "SELECT DISTINCT A.CONSTRUCTIONCODE, B.DETAILSTRING, A.OrderersDivision, A.OrderersCode";
+                    strSQL += " FROM CONSTRUCTIONBASEINFO A, CONSTRUCTIONBASEINFODETAIL B, PERSONINCHARGEMASTER C";
+                    strSQL += string.Format(" WHERE (A.CONSTRUCTIONCODE = B.CONSTRUCTIONCODE AND B.DETAILNO = {0})", (int)ConstructionBaseInfoDetail.DetailDataNo.ConstructionName);
+                    strSQL += string.Format(" AND A.JOINFLG = {0} ", (int)CommonDefine.BaseInfoJoinFlg.JoinParent);
+                    switch (m_PersonCharge)
+                    {
+                        case (int)PersonChargePoint.Sales:
+                            /// 営業担当検索
+                            strSQL += string.Format(" AND A.SalesPersonCode = {0}", m_PersonCode);
+                            break;
+                        case (int)PersonChargePoint.Construction:
+                            /// 工事担当者
+                            strSQL += string.Format(" AND (A.ConstructionPersonCode = {0} OR A.ConstrSubPersonCode = {0} OR A.ConstructionInstructor = {0})", m_PersonCode);
+                            break;
+                    }
+                    strSQL += " AND (C.PERSONCODE = A.SALESPERSONCODE";
+                    strSQL += " Or C.PERSONCODE = A.CONSTRUCTIONPERSONCODE";
+                    strSQL += " Or C.PERSONCODE = A.CONSTRSUBPERSONCODE";
+                    strSQL += " Or C.PERSONCODE = A.CONSTRUCTIONINSTRUCTOR)";
+                    strSQL += " ORDER BY B.DETAILSTRING ASC, A.CONSTRUCTIONCODE DESC";
+                }
+
                 ArrayList BaseList = new ArrayList();
                 if (!BaseDB.ExecuteReader(strSQL, ref BaseList)) return;
                 if (BaseList.Count == 0) return;
@@ -265,34 +462,29 @@
 
                 // 要素表示
                 int i = 0;
+                int[] iData = new int[2];
                 foreach (object[] wrk in BaseList)
                 {
+
+                    Array.Clear(iData, 0, iData.Length);
+
+                    if (m_ProcessNo == (int)ClsExcute.ProcessExecuteNo.OrderJoin)
+                    {
+                        iData[0] = CommonMotions.cnvInt(wrk[2]);
+                        iData[1] = CommonMotions.cnvInt(wrk[3]);
+                    }
+
                     // データ表示
                     int ConstructionCode = CommonMotions.cnvInt(wrk[0]);
-                    string EditConstructionCode = string.Format("{0}-{1}", (ConstructionCode / 100), (ConstructionCode % 100));
+                    string EditConstructionCode = string.Format("{0}-{1:D2}", (ConstructionCode / 100), (ConstructionCode % 100));
                     dgvMaster.Rows.Add((i + 1),
                                         EditConstructionCode,
                                         CommonMotions.cnvString(wrk[1]),
-                                        ConstructionCode);
-
+                                        ConstructionCode,
+                                        iData[0],
+                                        iData[1]);
                     dgvMaster.Rows[i++].Cells[(int)DispGridColumn.ConstructionName].ToolTipText = CommonMotions.cnvString(wrk[1]);
-
                 }
-                // 表示行が足りない場合の表示
-                if (dgvMaster.Rows.Count < CommonDefine.s_MaxInitLineCount)
-                {
-                    int AddRowCnt = CommonDefine.s_MaxInitLineCount - dgvMaster.Rows.Count;
-                    for (int ix = 0; ix < AddRowCnt; ix++)
-                    {
-                        string strDummy = string.Empty;
-
-                        int rowCnt = dgvMaster.Rows.Add(strDummy,
-                                                        strDummy,
-                                                        strDummy,
-                                                        false);
-                        dgvMaster.Rows[rowCnt].ReadOnly = true;
-                    }
-                }
             }
             catch (Exception ex)
             {
@@ -301,6 +493,8 @@
             finally
             {
                 BaseDB.close(); BaseDB = null;
+                dgvMaster.RowCount += (CommonDefine.s_MaxInitLineCount - dgvMaster.Rows.Count);
+
             }
         }
         /// <summary>
Index: branches/src/ProcessManagement/ProcessManagement/Forms/SubForms/FrmMessageBoardReader.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/SubForms/FrmMessageBoardReader.cs	(revision 50)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/SubForms/FrmMessageBoardReader.cs	(revision 51)
@@ -244,17 +244,12 @@
                 if (MessageBox.Show("表示中のメッセージを削除します。", "削除確認"
                         , MessageBoxButtons.YesNo, MessageBoxIcon.Question) != DialogResult.Yes) return;
 
-                if (MessageBoardDelete())
-                {
-                    // 削除成功時はメニューへ戻る
-                    while (true)
-                    {
-                        if (ClsExcute.ProcControlPara.Count == 0) break;
-                        // 前のプロセスを全て消す
-                        ClsExcute.BackProcess();
-                    }
-                }
+                if (!MessageBoardDelete()) return;
+                // 削除成功時はメニューへ戻る
+                ClsExcute.BackProcess();
 
+                CommonMotions.RemoveEndMessage("掲示板メッセージデータ");
+
                 m_EndButton = DialogResult.OK;
                 this.Close();
             }
@@ -312,7 +307,7 @@
                 MessageBoardData data = new MessageBoardData();
                 if (!mbdDB.SelectAction(strSQL, ref data)) return;
 
-                lblTitle.Text = data.MessageTitle;        // タイトル
+                lblTitle.Text = data.MessageTitle;          // タイトル
                 lblWriter.Text = data.FromName;             // 書込み者
 
                 //  対象者名表示
@@ -324,7 +319,6 @@
                     foreach (MessageBoardTerget wrkterget in terList)
                     {
                         lstRecipient.Items.Add(wrkterget.ToName);
-                        
                     }
                 }
 
@@ -348,11 +342,8 @@
                     m_DataOwner = true;
                 }
 
-                // ログイン者が管理者ならばメッセージを削除できる
-                bool bDeleteFlg = false;
-                if (ClsMessageBoradAccess.MessageAccessPermission(m_RecordNumber, m_BranchNumber, false)) bDeleteFlg = true;
-
-                if (bDeleteFlg)
+                // ログイン者が管理者・所属長以上ならばメッセージを削除できる
+                if (ClsMessageBoradAccess.MessagePermission(m_RecordNumber, m_BranchNumber, false))
                 {
                     int xPoint = btnDelete.Location.X;
                     int yPoint = btnDelete.Location.Y;
@@ -529,7 +520,7 @@
 
                 if (!MesHisDB.InsertAction(MesHisRec))
                 {
-                    logger.ErrorFormat("掲示板書込みエラー", CommonMotions.GetMethodName());
+                    logger.ErrorFormat("掲示板書込みエラー：{0}", CommonMotions.GetMethodName());
                 }
             }
             catch (Exception ex)
Index: branches/src/ProcessManagement/ProcessManagement/Forms/SubForms/FrmMessageBoardWriter.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/SubForms/FrmMessageBoardWriter.cs	(revision 50)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/SubForms/FrmMessageBoardWriter.cs	(revision 51)
@@ -220,17 +220,13 @@
                         , MessageBoxButtons.YesNo, MessageBoxIcon.Question) != DialogResult.Yes) return;
 
                 // データ登録
-                if (MessageBoardEntry())
-                {
-                    // 書込み成功時はメニューへ戻る
-                    while (true)
-                    {
-                        if (ClsExcute.ProcControlPara.Count == 0) break;
-                        // 前のプロセスを全て消す
-                        ClsExcute.BackProcess();
-                    }
-                }
+                if (!MessageBoardEntry()) return;
 
+                // 書込み成功時はメニューへ戻る
+                ClsExcute.BackProcess();
+
+                CommonMotions.EntryEndMessage("掲示板メッセージデータ");
+
                 m_bChengeAns = false;
                 m_EndButton = DialogResult.OK;
                 this.Close();
Index: branches/src/ProcessManagement/ProcessManagement/Forms/SubForms/FrmNumberOfWorkers.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/SubForms/FrmNumberOfWorkers.cs	(revision 50)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/SubForms/FrmNumberOfWorkers.cs	(revision 51)
@@ -280,6 +280,7 @@
             {
                 // 年月カラム数を取得する
                 string strSQL = "SELECT";
+                //strSQL += " TO_CHAR(A.DAILYDATADATE, 'YYYY/MM')";
                 strSQL += " DATE_FORMAT(A.DAILYDATADATE, '%Y/%m')";
                 strSQL += " FROM DAILYDATADETAIL A";
                 strSQL += " LEFT JOIN SUBCONTRACTORJOBCATEGORY B ON A.JOBCATEGORYCODE = B.JOBCATEGORYCODE";
@@ -286,6 +287,7 @@
                 strSQL += " LEFT JOIN  SUBCONTRACTORMASTER C ON A.COMPANYCODE = C.COMPANYCODE";
                 strSQL += string.Format(" WHERE PersonCode = {0}", m_PersonCode);
                 strSQL += string.Format(" AND ConstructionCode = {0}", m_ConstructionCode);
+                //strSQL += " group By TO_CHAR(A.DAILYDATADATE, 'YYYY/MM')";
                 strSQL += " group By DATE_FORMAT(A.DAILYDATADATE, '%Y/%m')";
                 strSQL += " ORDER BY 1";
                 ArrayList arList = new ArrayList();
@@ -410,6 +412,7 @@
                 dgvMain.Rows.Clear();
                 string strSQL = "SELECT";
                 strSQL += " A.JOBCATEGORYCODE, B.JOBCATEGORYNAME, A.COMPANYCODE,";
+                //strSQL += " C.COMPANYNAME, TO_CHAR(A.DAILYDATADATE, 'YYYY/MM'), SUM(A.TODAYHEADCOUNT)";
                 strSQL += " C.COMPANYNAME, DATE_FORMAT(A.DAILYDATADATE, '%Y/%m'), SUM(A.TODAYHEADCOUNT)";
                 strSQL += " FROM DAILYDATADETAIL A";
                 strSQL += " LEFT JOIN SUBCONTRACTORJOBCATEGORY B ON A.JOBCATEGORYCODE = B.JOBCATEGORYCODE";
@@ -416,6 +419,7 @@
                 strSQL += " LEFT JOIN SUBCONTRACTORMASTER C ON A.COMPANYCODE = C.COMPANYCODE";
                 strSQL += string.Format(" WHERE PersonCode = {0}", m_PersonCode);
                 strSQL += string.Format(" AND ConstructionCode = {0}", m_ConstructionCode);
+                //strSQL += " GROUP BY A.JOBCATEGORYCODE, B.JOBCATEGORYNAME, A.COMPANYCODE, C.COMPANYNAME, TO_CHAR(A.DAILYDATADATE, 'YYYY/MM')";
                 strSQL += " GROUP BY A.JOBCATEGORYCODE, B.JOBCATEGORYNAME, A.COMPANYCODE, C.COMPANYNAME, DATE_FORMAT(A.DAILYDATADATE, '%Y/%m')";
                 strSQL += " ORDER BY 3, 1, 4";
 
